package com.jiuqi.gl.ar.ui;

import com.jiuqi.dna.bap.basedata.common.control.BDInputControlParam;
import com.jiuqi.dna.bap.basedata.common.control.BaseDataInputControl;
import com.jiuqi.dna.bap.basedata.common.util.BaseDataCenter;
import com.jiuqi.dna.bap.basedata.intf.facade.FBaseDataInfo;
import com.jiuqi.dna.bap.basedata.intf.facade.FBaseDataObject;
import com.jiuqi.dna.bap.basedata.intf.info.QueryObjectListInfo;
import com.jiuqi.dna.bap.basedata.intf.util.BapISelectCallBack;
import com.jiuqi.dna.bap.bill.common.model.BillCentre;
import com.jiuqi.dna.bap.bill.common.model.BillModel;
import com.jiuqi.dna.bap.bill.intf.facade.model.FBillDefine;
import com.jiuqi.dna.bap.model.common.define.base.BusinessObject;
import com.jiuqi.dna.core.da.RecordSet;
import com.jiuqi.dna.core.da.RecordSetField;
import com.jiuqi.dna.core.situation.MessageListener;
import com.jiuqi.dna.core.situation.MessageTransmitter;
import com.jiuqi.dna.core.situation.Situation;
import com.jiuqi.dna.core.type.GUID;
import com.jiuqi.dna.ui.template.launch.TemplateWindow;
import com.jiuqi.dna.ui.wt.widgets.Composite;
import com.jiuqi.dna.ui.wt.widgets.Form;
import com.jiuqi.dna.ui.wt.widgets.MessageDialog;
import com.jiuqi.gl.ar.ui.PercentBadDebtHandlerPageControls;
import com.jiuqi.vacomm.env.EnvCenter;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Comparator;
import java.util.Date;
import java.util.List;

/* loaded from: com_jiuqi_gl_ar_ui.jar:com/jiuqi/gl/ar/ui/PercentBadDebtHandlerPage.class */
public class PercentBadDebtHandlerPage<TControls extends PercentBadDebtHandlerPageControls> extends Form<PercentBadDebtHandlerPageControls> {
    private BaseDataInputControl control;
    private FBillDefine ysBillDefine;
    private static final String dnaSql = "DEFINE QUERY arBillQuery()\n BEGIN\n\tSELECT\n\t\tT.RECID AS RECID\n\tFROM %1$s AS T\n\tWHERE\n\t\tT.REGISTEDATE<date'%2$s'\n\t\tAND T.DEFINEID=guid'%3$s'\n\t\tAND T.CF>0\n\t\tAND T.HZJTFSID<>guid'%4$s'\n\t\tAND T.UNITID=guid'%5$s'\n\t\tAND T.WORKFLOWSTATE<>0 AND T.WORKFLOWSTATE<>3 AND T.WORKFLOWSTATE<>5\nEND\n";
    private double[] rates;

    public PercentBadDebtHandlerPage(Composite parent) {
        super(parent);
        initUI();
        addListeners();
    }

    private void addListeners() {
        getContext().regMessageListener(TemplateWindow.ButtonMessage.class, new MessageListener<TemplateWindow.ButtonMessage>() { // from class: com.jiuqi.gl.ar.ui.PercentBadDebtHandlerPage.1
            public /* bridge */ /* synthetic */ void onMessage(Situation situation, Object obj, MessageTransmitter messageTransmitter) {
                onMessage(situation, (TemplateWindow.ButtonMessage) obj, (MessageTransmitter<TemplateWindow.ButtonMessage>) messageTransmitter);
            }

            public void onMessage(Situation context, TemplateWindow.ButtonMessage message, MessageTransmitter<TemplateWindow.ButtonMessage> transmitter) {
                if (message.buttonType == 256) {
                    if (PercentBadDebtHandlerPage.this.control.getSelection() == null) {
                        MessageDialog.alert("组织机构不能为空。");
                        message.closeWindow = false;
                        return;
                    }
                    try {
                        PercentBadDebtHandlerPage.this.generateBill();
                        message.closeWindow = true;
                    } catch (Exception e) {
                        message.closeWindow = false;
                        MessageDialog.alert(e.getMessage());
                    }
                }
            }
        });
    }

    /* JADX INFO: Access modifiers changed from: private */
    public void generateBill() {
        this.ysBillDefine = BillCentre.findBillDefine(getContext(), ArBillConst.AR_YRZ_BILLDEFINE);
        if (this.ysBillDefine == null) {
            throw new RuntimeException("找不到【应收账款登记单(AR_YRZ)】的单据定义。");
        }
        FBillDefine jtBillDefine = BillCentre.findBillDefine(getContext(), ArBillConst.AR_JTHZ_TABLE);
        if (jtBillDefine == null) {
            throw new RuntimeException("找不到【应收坏账准备计提(AR_JTHZZB)】的单据定义。");
        }
        BillModel ysBillModel = BillCentre.createBillModel(getContext(), this.ysBillDefine);
        BillModel jtBillModel = BillCentre.createBillModel(getContext(), jtBillDefine);
        int count = 0;
        for (GUID arBillID : getArYRZBillIDs(((PercentBadDebtHandlerPageControls) this.controls).dap_Date.getDate(), this.control.getSelection().getObjectID())) {
            ysBillModel.load(arBillID);
            BusinessObject ysMaster = ysBillModel.getModelData().getMaster();
            double cf = ysMaster.getValueAsDouble(ArBillConst.AR_YRZ_CF_FIELD);
            double hasJTJE = ysMaster.getValueAsDouble("HZJTJE");
            Date rzDate = ysMaster.getValueAsDate(ArBillConst.AR_YRZ_REGISTEDATE_FIELD);
            double rate = getJTRate(rzDate, ((PercentBadDebtHandlerPageControls) this.controls).dap_Date.getDate());
            if ((cf * rate) - hasJTJE > 0.01d) {
                jtBillModel.add();
                BusinessObject jtMaster = jtBillModel.getModelData().getMaster();
                jtMaster.setFieldValue(ArBillConst.AR_JTHZ_YSDID_FIELD, ysMaster.getRECID());
                jtMaster.setFieldValue("HZJTFSID", getZLBFBID());
                jtMaster.setFieldValue("HZJTJE", Double.valueOf((cf * rate) - hasJTJE));
                jtMaster.setFieldValue(ArBillConst.AR_LJJTJE_FIELD, Double.valueOf(cf * rate));
                jtMaster.setFieldValue(ArBillConst.AR_JTHZ_JTRQ_FIELD, ((PercentBadDebtHandlerPageControls) this.controls).dap_Date.getDate());
                jtMaster.setFieldValue(ArBillConst.AR_JTHZ_YSDCODE_FIELD, ysMaster.getValueAsString(ArBillConst.AR_YRZ_BILLCODE_FIELD));
                jtBillModel.save();
                ysMaster.setFieldValue("HZJTJE", Double.valueOf(cf * rate));
                ysBillModel.update();
                count++;
            }
        }
        MessageDialog.alert("操作成功。生成" + count + "张坏账计提准备单据。");
    }

    private void initUI() {
        BDInputControlParam param = new BDInputControlParam(((PercentBadDebtHandlerPageControls) this.controls).cmp_Org);
        param.setMode(BaseDataInputControl.Mode.NORMAL);
        param.setMult(false);
        this.control = new BaseDataInputControl(param);
        this.control.setTableName("MD_ORG");
        this.control.setSelectCallBack(new BapISelectCallBack() { // from class: com.jiuqi.gl.ar.ui.PercentBadDebtHandlerPage.2
            public boolean canListGroup(FBaseDataInfo info) {
                return true;
            }

            public boolean canListGroup(FBaseDataObject object) {
                return true;
            }

            public boolean canList(FBaseDataObject object) {
                return true;
            }

            public boolean canSelect(FBaseDataObject object) {
                return true;
            }

            public void doSelect(FBaseDataObject object) {
            }

            public FBaseDataObject getSelection() {
                return null;
            }

            public boolean showDummyRoot() {
                return false;
            }

            public FBaseDataObject getRootObject() {
                return null;
            }

            public boolean canSelectBranch() {
                return true;
            }
        });
        this.control.buildControl();
        this.control.setSelection(BaseDataCenter.findObject(getContext(), "MD_ORG", EnvCenter.getCurrUnitId(getContext())));
        ((PercentBadDebtHandlerPageControls) this.controls).dap_Date.setDate(new Date());
    }

    private List<GUID> getArYRZBillIDs(Date date, GUID orgID) {
        List<GUID> billIDs = new ArrayList<>();
        String execSQL = String.format(dnaSql, this.ysBillDefine.getMasterTable().getName(), new SimpleDateFormat("yyyy-MM-dd").format(date), this.ysBillDefine.getBillInfo().getRecID(), getGBRDFID().toString(), orgID.toString());
        RecordSet rs = getContext().prepareStatement(execSQL).executeQuery();
        while (rs.next()) {
            billIDs.add(((RecordSetField) rs.getFields().get(0)).getGUID());
        }
        return billIDs;
    }

    private GUID getGBRDFID() {
        return BaseDataCenter.findObject(getContext(), ArBillConst.HZJTFS_TABLE, ArBillConst.HZJTFS_GBRDF).getRECID();
    }

    private GUID getZLBFBID() {
        return BaseDataCenter.findObject(getContext(), ArBillConst.HZJTFS_TABLE, ArBillConst.HZJTFS_ZLBFBF).getRECID();
    }

    private double getJTRate(Date rzDate, Date queryDate) {
        if (this.rates == null) {
            QueryObjectListInfo queryInfo = new QueryObjectListInfo(ArBillConst.ZTQJ_TABLE);
            queryInfo.setCmp(new Comparator<FBaseDataObject>() { // from class: com.jiuqi.gl.ar.ui.PercentBadDebtHandlerPage.3
                @Override // java.util.Comparator
                public int compare(FBaseDataObject arg0, FBaseDataObject arg1) {
                    return arg0.getStdCode().compareTo(arg1.getStdCode());
                }
            });
            List<FBaseDataObject> zlqjObjs = BaseDataCenter.getObjectList(getContext(), queryInfo);
            int size = zlqjObjs.size();
            this.rates = new double[size];
            for (int i = 0; i < size; i++) {
                this.rates[i] = zlqjObjs.get(i).getValueAsDouble(ArBillConst.ZTQJ_RATE_FIELD);
            }
        }
        Calendar rzCalendar = Calendar.getInstance();
        Calendar queryCalendar = Calendar.getInstance();
        queryCalendar.setTime(queryDate);
        for (int i2 = 5; i2 >= 0; i2--) {
            rzCalendar.setTime(rzDate);
            rzCalendar.add(1, i2);
            if (rzCalendar.before(queryCalendar)) {
                return this.rates[i2];
            }
        }
        return 0.0d;
    }
}
